import Button from "@/components/Low/Button";
import useUsers from "@/hooks/useUsers";
import {Type as UserType, User} from "@/interfaces/user";
import axios from "axios";
import {uniqBy} from "lodash";
import {useEffect, useState} from "react";
import {toast} from "react-toastify";
import {useFilePicker} from "use-file-picker";
import readXlsxFile from "read-excel-file";
import Modal from "@/components/Modal";
import {BsQuestionCircleFill} from "react-icons/bs";
import {PermissionType} from "@/interfaces/permissions";
import moment from "moment";
import {checkAccess, getTypesOfUser} from "@/utils/permissions";
import Checkbox from "@/components/Low/Checkbox";
import ReactDatePicker from "react-datepicker";
import clsx from "clsx";
import usePermissions from "@/hooks/usePermissions";
import countryCodes from "country-codes-list";

const EMAIL_REGEX = new RegExp(/^[a-zA-Z0-9]+(?:\.[a-zA-Z0-9]+)*@[a-zA-Z0-9]+(?:\.[a-zA-Z0-9]+)*$/);

type Type = Exclude<UserType, "admin" | "developer" | "agent" | "mastercorporate">;

const USER_TYPE_LABELS: {[key in Type]: string} = {
	student: "Student",
	teacher: "Teacher",
	corporate: "Corporate",
};

const USER_TYPE_PERMISSIONS: {
	[key in UserType]: {perm: PermissionType | undefined; list: UserType[]};
} = {
	student: {
		perm: "createCodeStudent",
		list: [],
	},
	teacher: {
		perm: "createCodeTeacher",
		list: [],
	},
	agent: {
		perm: "createCodeCountryManager",
		list: ["student", "teacher", "corporate", "mastercorporate"],
	},
	corporate: {
		perm: "createCodeCorporate",
		list: ["student", "teacher"],
	},
	mastercorporate: {
		perm: undefined,
		list: ["student", "teacher", "corporate"],
	},
	admin: {
		perm: "createCodeAdmin",
		list: ["student", "teacher", "agent", "corporate", "admin", "mastercorporate"],
	},
	developer: {
		perm: undefined,
		list: ["student", "teacher", "agent", "corporate", "admin", "developer", "mastercorporate"],
	},
};

interface Props {
	user: User;
	users: User[];
	permissions: PermissionType[];
	onFinish: () => void;
}

export default function BatchCreateUser({user, users, permissions, onFinish}: Props) {
	const [infos, setInfos] = useState<
		{
			email: string;
			name: string;
			passport_id: string;
			type: Type;
			demographicInformation: {
				country: string;
				passport_id: string;
				phone: string;
			};
		}[]
	>([]);
	const [isLoading, setIsLoading] = useState(false);
	const [expiryDate, setExpiryDate] = useState<Date | null>(
		user?.subscriptionExpirationDate ? moment(user.subscriptionExpirationDate).toDate() : null,
	);
	const [isExpiryDateEnabled, setIsExpiryDateEnabled] = useState(true);
	const [type, setType] = useState<Type>("student");
	const [showHelp, setShowHelp] = useState(false);

	const {openFilePicker, filesContent, clear} = useFilePicker({
		accept: ".xlsx",
		multiple: false,
		readAs: "ArrayBuffer",
	});

	useEffect(() => {
		if (!isExpiryDateEnabled) setExpiryDate(null);
	}, [isExpiryDateEnabled]);

	useEffect(() => {
		if (filesContent.length > 0) {
			const file = filesContent[0];
			readXlsxFile(file.content).then((rows) => {
				try {
					const information = uniqBy(
						rows
							.map((row) => {
								const [firstName, lastName, studentID, passport_id, email, phone, corporate, group, country] = row as string[];
								const countryItem =
									countryCodes.findOne("countryCode" as any, country.toUpperCase()) ||
									countryCodes.all().find((x) => x.countryNameEn.toLowerCase() === country.toLowerCase());

								return EMAIL_REGEX.test(email.toString().trim())
									? {
											email: email.toString().trim().toLowerCase(),
											name: `${firstName ?? ""} ${lastName ?? ""}`.trim(),
											type: type,
											passport_id: passport_id?.toString().trim() || undefined,
											groupName: group,
											corporate,
											studentID,
											demographicInformation: {
												country: countryItem?.countryCode,
												passport_id: passport_id?.toString().trim() || undefined,
												phone,
											},
									  }
									: undefined;
							})
							.filter((x) => !!x) as typeof infos,
						(x) => x.email,
					);

					if (information.length === 0) {
						toast.error(
							"Please upload an Excel file containing user information, one per line! All already registered e-mails have also been ignored!",
						);
						return clear();
					}

					setInfos(information);
				} catch {
					toast.error(
						"Please upload an Excel file containing user information, one per line! All already registered e-mails have also been ignored!",
					);
					return clear();
				}
			});
		}
		// eslint-disable-next-line react-hooks/exhaustive-deps
	}, [filesContent]);

	const makeUsers = async () => {
		const newUsers = infos.filter((x) => !users.map((u) => u.email).includes(x.email));
		if (!confirm(`You are about to add ${newUsers.length}, are you sure you want to continue?`)) return;

		if (newUsers.length > 0) {
			setIsLoading(true);

			try {
				for (const newUser of newUsers) await axios.post("/api/make_user", {...newUser, type, expiryDate});
				toast.success(`Successfully added ${newUsers.length} user(s)!`);
				onFinish();
			} catch {
				toast.error("Something went wrong, please try again later!");
			} finally {
				setIsLoading(false);
				setInfos([]);
				clear();
			}
		}
	};

	return (
		<>
			<Modal isOpen={showHelp} onClose={() => setShowHelp(false)} title="Excel File Format">
				<div className="mt-4 flex flex-col gap-2">
					<span>Please upload an Excel file with the following format:</span>
					<table className="w-full">
						<thead>
							<tr>
								<th className="border border-neutral-200 px-2 py-1">First Name</th>
								<th className="border border-neutral-200 px-2 py-1">Last Name</th>
								<th className="border border-neutral-200 px-2 py-1">Student ID</th>
								<th className="border border-neutral-200 px-2 py-1">Passport/National ID</th>
								<th className="border border-neutral-200 px-2 py-1">E-mail</th>
								<th className="border border-neutral-200 px-2 py-1">Phone Number</th>
								{user?.type !== "corporate" && <th className="border border-neutral-200 px-2 py-1">Corporate (e-mail)</th>}
								<th className="border border-neutral-200 px-2 py-1">Group Name</th>
								<th className="border border-neutral-200 px-2 py-1">Country</th>
							</tr>
						</thead>
					</table>
					<span className="mt-4">
						<b>Notes:</b>
						<ul>
							<li>- All incorrect e-mails will be ignored;</li>
							<li>- All already registered e-mails will be ignored;</li>
							<li>- You may have a header row with the format above, however, it is not necessary;</li>
							<li>- All of the e-mails in the file will receive an e-mail to join EnCoach with the role selected below.</li>
						</ul>
					</span>
				</div>
			</Modal>
			<div className="border-mti-gray-platinum flex flex-col gap-4 rounded-xl border p-4">
				<div className="flex items-end justify-between">
					<label className="text-mti-gray-dim text-base font-normal">Choose an Excel file</label>
					<div className="tooltip cursor-pointer" data-tip="Excel File Format" onClick={() => setShowHelp(true)}>
						<BsQuestionCircleFill />
					</div>
				</div>
				<Button onClick={openFilePicker} isLoading={isLoading} disabled={isLoading}>
					{filesContent.length > 0 ? filesContent[0].name : "Choose a file"}
				</Button>
				{user && checkAccess(user, ["developer", "admin", "corporate", "mastercorporate"]) && (
					<>
						<div className="-md:flex-row -md:items-center flex justify-between gap-2 md:flex-col 2xl:flex-row 2xl:items-center">
							<label className="text-mti-gray-dim text-base font-normal">Expiry Date</label>
							<Checkbox isChecked={isExpiryDateEnabled} onChange={setIsExpiryDateEnabled} disabled={!!user.subscriptionExpirationDate}>
								Enabled
							</Checkbox>
						</div>
						{isExpiryDateEnabled && (
							<ReactDatePicker
								className={clsx(
									"flex min-h-[70px] w-full cursor-pointer justify-center rounded-full border p-6 text-sm font-normal focus:outline-none",
									"hover:border-mti-purple tooltip",
									"transition duration-300 ease-in-out",
								)}
								filterDate={(date) =>
									moment(date).isAfter(new Date()) &&
									(user.subscriptionExpirationDate ? moment(date).isBefore(user.subscriptionExpirationDate) : true)
								}
								dateFormat="dd/MM/yyyy"
								selected={expiryDate}
								onChange={(date) => setExpiryDate(date)}
							/>
						)}
					</>
				)}
				<label className="text-mti-gray-dim text-base font-normal">Select the type of user they should be</label>
				{user && (
					<select
						defaultValue="student"
						onChange={(e) => setType(e.target.value as Type)}
						className="flex min-h-[70px] w-full min-w-[350px] cursor-pointer justify-center rounded-full border bg-white p-6 text-sm font-normal focus:outline-none">
						{Object.keys(USER_TYPE_LABELS)
							.filter((x) => {
								const {list, perm} = USER_TYPE_PERMISSIONS[x as Type];
								// if (x === "corporate") console.log(list, perm, checkAccess(user, list, permissions, perm));
								return checkAccess(user, getTypesOfUser(list), permissions, perm);
							})
							.map((type) => (
								<option key={type} value={type}>
									{USER_TYPE_LABELS[type as keyof typeof USER_TYPE_LABELS]}
								</option>
							))}
					</select>
				)}
				<Button className="my-auto" onClick={makeUsers} disabled={infos.length === 0}>
					Create
				</Button>
			</div>
		</>
	);
}
